{
  Caption property editor  16/32 bit
  let you type in multiline Caption for each TCustomLabel
  or Tabs using Ctrl TAB
  install like a component

  based on THintEdit by Richard Hansen CompuServe 71043,2142

  This source code may be freely distributed and used. The author
  accepts no responsibility for its use or misuse.

  Michael Richter 2. March 1997
  mri@leguan.ba-glauchau.de
}

unit CaptEdit;

interface

uses
  WinTypes, WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, DsgnIntf;

type
  TCaptionPropertyEditor = class(TForm)
    Memo: TMemo;
    OK: TButton;
    Abbrechen: TButton;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
  public
  end;

  TCaptionProperty = class(TStringProperty)
  private
  protected
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  published
  end;


procedure Register;

implementation

{$R *.DFM}

procedure Register;
begin
  RegisterPropertyEditor(TypeInfo(TCaption), TCustomLabel, 'Caption', TCaptionProperty);
end;

procedure TCaptionPropertyEditor.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #27 then Close;
end;

function TCaptionProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog, paMultiSelect, paAutoUpdate];
end;

procedure TCaptionProperty.Edit;

  procedure ParseText(Lines : TStrings; const S : String);
  var
    x : Integer;
    Temp : String;
  begin
    if (S <> '') then begin
      Temp := '';
      for x := 1 to Length(S) do begin
        if S[x] = #13 then begin
          Lines.Add(Temp);
          Temp := '';
        end else
          Temp := Temp + S[x];
      end;
      if (Temp <> '') then Lines.Add(Temp);
    end;
  end;

  procedure ExtractText(Lines : TStrings; var S : String);
  var
    x : Integer;
  begin
    for x := 0 to Lines.Count - 1 do begin
      if (x <> 0) then S := S + #13;
      S := S + Lines[x];
    end
  end;

var
  Editor: TCaptionPropertyEditor;
  S : String;
begin
  Editor := TCaptionPropertyEditor.Create(Application);
  if GetComponent(0) is TLabel then Editor.Memo.Alignment := TLabel(GetComponent(0)).Alignment;
  try
    ParseText(Editor.Memo.Lines, GetStrValue);
    if (Editor.ShowModal = mrOK) then begin
      S := '';
      ExtractText(Editor.Memo.Lines, S);
      SetStrValue(S);
    end;
  finally
    Editor.Free;
  end;
end;

end.

